int receive_bank(void)

{
 int count;
 int ack_ok;
 int buffer_location;
 int retries=0;

 patches_downloaded=0; 
 for (count=0;count<=15;count++)
 {
  ack_ok=1;
  midi_out_buffer[0]=(char)0xF0;
  midi_out_buffer[1]=(char)0x44;
  midi_out_buffer[2]=(char)0x00;
  midi_out_buffer[3]=(char)0x00;
  midi_out_buffer[4]=(char)0x70+(midi_channel_num-1);
  midi_out_buffer[5]=(char)0x10;
  if (cz_memory==0) midi_out_buffer[6]=(char)0x00+count;
  if (cz_memory==1) midi_out_buffer[6]=(char)0x20+count;
  if (cz_memory==2) midi_out_buffer[6]=(char)0x40+count;
  midi_out_buffer[7]=(char)0x70+(midi_channel_num-1);
  midi_out_buffer[8]=(char)0x31;
  midi_out_buffer[9]=(char)0xF7;

  midi_prepare();
  midi_send(10);
  midi_pause(1300);

  if (midi_receive()<263) ack_ok=0;
  if (midi_in_buffer[0]!=(char)0xF0) ack_ok=0;
  if (midi_in_buffer[1]!=(char)0x44) ack_ok=0;
  if (midi_in_buffer[2]!=(char)0x00) ack_ok=0;
  if (midi_in_buffer[3]!=(char)0x00) ack_ok=0;
  if (midi_in_buffer[5]!=(char)0x30) ack_ok=0;
  if (midi_in_buffer[262]!=(char)0xF7) ack_ok=0;
 
  if (ack_ok==0)
  {
   retries++;
   if (retries<=5)
   {
	count=count-1;
   }
  }

  /* retries failed */
  if ((retries==5)&&(ack_ok==0))
  {
   error_code=2;
   draw_cz_window();
   return(patches_downloaded);
  }

  if (ack_ok==1)
  {
   retries=0;

   patches_downloaded++; 
   text_value=(count+1);
   status_code=1;
   draw_cz_window();
   
   fputc(0xF0,syxfile);
   fputc(0x44,syxfile);
   fputc(0x00,syxfile);
   fputc(0x00,syxfile);
   fputc(0x70,syxfile);
   fputc(0x20,syxfile);
   fputc(0x20+count,syxfile);
   for (buffer_location=1;buffer_location<=256;
    buffer_location++)
   {
	fputc(midi_in_buffer[5+buffer_location],syxfile);
   }
   fputc(0xF7,syxfile);
  }
 }

 text_value=patches_downloaded;
 status_code=2;
 draw_cz_window();
 return(patches_downloaded);
}


